﻿<template>
  <div>
    <label class="task-list-container" v-for="n in tasks" :key="n.id">
      <task-form
        v-if="n.id % 2 === 1 || !isMobile"
        class="task-model-list"
        :task="n"
      />

      <task-form
        v-if="n.id % 2 === 0 && isMobile"
        class="task-model-list-right"
        :task="n"
      />
    </label>

    <new-task-button class="create-task-button" />
  </div>
</template>

<script>
import TaskForm from "./TaskForm.vue";
import NewTaskButton from "./NewTaskButton.vue";

export default {
  name: "TaskList",
  components: {
    TaskForm,
    NewTaskButton,
  },
  computed: {
    tasks() {
      return this.$store.getters["tasks/undoneTasks"];
    },
  },
  data() {
    return {
      isMobile: false,
    };
  },
  beforeDestroy() {
    if (typeof window === "undefined") return;

    window.removeEventListener("resize", this.onResize, { passive: true });
  },

  mounted() {
    this.onResize();

    window.addEventListener("resize", this.onResize, { passive: true });
  },

  methods: {
    onResize() {
      this.isMobile = window.innerWidth < 960;
    },
  },
};
</script>

<style lang="sass">
@import "../../scss/media_mixin.sass"

.task-list-container
  width: 500px

.create-task-button
  display: inline-block
  margin: 15px
  @include media_960
    position: fixed
    bottom: 24px
    right: 20px

.task-model-list
  margin: 15px
  @include media_960
    margin:
      left: 34px
      right: 34px
      bottom: 23px

.task-model-list-right
  @include media_960
    margin:
      left: 216px
      right: 34px
      bottom: 23px
</style>
